// uuid: 2460e386-36d9-49ec-afd6-30963ab2e387

// ------------------------------------------------------------------------
// Copyright (c) 2018 Alexandre Bento Freire. All rights reserved.
// Licensed under the MIT License+uuid License. See License.txt for details
// ------------------------------------------------------------------------

"use strict";
Object.defineProperty(exports,"__esModule",{value:!0});var ServerAgent,version_js_1=require("../shared/version.js"),rel_consts_js_1=require("../shared/rel-consts.js"),consts_js_1=require("../shared/lib/consts.js"),opts_parser_js_1=require("../shared/opts-parser.js"),server_consts_js_1=require("../shared/lib/server-consts.js"),sprintf_js_1=require("../shared/lib/sprintf.js"),plugin_injector_js_1=require("./plugin-injector.js");!function(e){var s=server_consts_js_1.ServerConsts._SRV_CNT,r=sprintf_js_1.Sprintf.sprintf,t=2;function i(e){return e.replace(/\\/g,"/")}function o(e){var s=e.lastIndexOf("/");return-1===s?".":e.substr(0,s)}e.toPosixSlash=i;var a=!0,n=function(){function e(e,s,r,t,i,o,a,n,h,c,l){var p=this;this.serverName=e,this.args=s,this.platform=r,this.cwd=t,this.existsSync=i,this.isDirectory=o,this.unlinkSync=a,this.mkdirpSync=n,this.readUtf8Sync=h,this.writeFileSync=c,this.posixPathJoin=l,this.reportFileName=opts_parser_js_1.OptsParser.DEFAULT_OUT_REPORT,this.width=rel_consts_js_1.RelConsts.DEFAULT_WIDTH,this.height=rel_consts_js_1.RelConsts.DEFAULT_HEIGHT,this.timeout=0,this.maxWidth=opts_parser_js_1.OptsParser.DEFAULT_MAX_WIDTH,this.maxHeight=opts_parser_js_1.OptsParser.DEFAULT_MAX_HEIGHT,this.maxFps=opts_parser_js_1.OptsParser.DEFAULT_MAX_FPS,this.maxFrameCount=opts_parser_js_1.OptsParser.DEFAULT_MAX_FRAME_COUNT,this.progress=opts_parser_js_1.OptsParser.DEFAULT_PROGRESS,this.url="",this.framesPattern="",this.projDir="",this.fps=1,this.logLevel=consts_js_1.Consts.LL_WARN,this.isVerbose=!1,this.toDeletePreviousVersion=!1,this.toGenFrames=!0,this.toTeleport=!1,this.rootPath="",this.configPath="",this.frameNr=0,this.frameCount=0,this.getViewport=function(){var e={width:p.width,height:p.height};return p.isVerbose&&console.log("width: "+e.width+", height: "+e.height),e}}return e.prototype.exitServer=function(e){void 0===e&&(e=0),this.logLevel&&console.log("Terminating Server")},e.prototype.getPageUrl=function(){var e=this.url+(-1===this.url.indexOf("?")?"?":"&")+s.SERVER_SUFFIX+this.serverName+"&"+s.LOG_LEVEL_SUFFIX+this.logLevel+"&"+s.TELEPORT_SUFFIX+this.toTeleport.toString();return 0!==this.logLevel&&(console.log("pageUrl: ["+e+"]"),console.log("serverless pageUrl: ["+this.url+"]")),e},e.prototype.parseJsonConfig=function(e,s,r,t){var i=this,a=s.config;if(a){var n=a.abeamer;n&&(e.splice(0,t+1),t=0,this.projDir=this.projDir||o(r),Object.keys(n).forEach(function(s){switch(s){case"plugins":plugin_injector_js_1.PluginInjector.plugins=n[s]||[];break;case"file":case"report":case"fps":case"out":case"height":case"width":e.push("--"+s,n[s].toString().replace("__PROJDIR__",i.projDir))}}))}return t},e.prototype.parseIniCfgContent=function(e){var s=this,r={};return e.split(/\n/).forEach(function(e){return e.replace(/^\s*[\$@]abeamer-([\w+-]+)\s*:\s*"?([^\n"]+)"?\s*;\s*$/,function(e,t,i){return s.isVerbose&&console.log("config: "+t+"=["+i+"]"),r[t]=i,""})}),r},e.prototype.parseConfig=function(e,s,r,t){return this.parseJsonConfig(e,r.match(/\.json$/)?JSON.parse(s):{config:{abeamer:this.parseIniCfgContent(s)}},r,t)},e.prototype.parseArguments=function(e){var s=1,r=this;function a(e){var s=i(e);if(!s)return"";if(r.existsSync(s)&&r.isDirectory(s)&&(s=r.posixPathJoin(s,"abeamer.ini")),!r.existsSync(s))throw"Config file "+s+" doesn't exists";return s}return opts_parser_js_1.OptsParser.iterateArgOpts(!0,function(){return e[s++]},function n(h,c){switch(h){case"@param":n("config",a(i(c)));break;case"version":return console.log(version_js_1.VERSION),t;case"ll":r.logLevel=c,r.isVerbose=r.logLevel>=consts_js_1.Consts.LL_VERBOSE,r.isVerbose&&console.log("Args: ["+e.join("],[")+"]");break;case"url":r.url=c,r.isVerbose&&console.log("url: "+r.url);break;case"file":var l=i(c),p=-1!==r.platform.indexOf("win");if((p?":"!==l[1]&&"/"!==l[2]:"/"!==l[0])&&(r.rootPath=i(r.cwd)+"/"),r.projDir=o(l),r.framesPattern||(r.framesPattern=r.projDir+opts_parser_js_1.OptsParser.DEFAULT_OUT_PATTERN),!r.existsSync(l))throw"Page File "+l+" doesn't exists";r.url||(r.url="file://"+(p?"/":"")+encodeURI(r.rootPath+l),r.isVerbose&&console.log("final url: "+r.url));break;case"out":r.framesPattern=i(c).replace("__PROJDIR__",r.projDir),r.isVerbose&&r.toGenFrames&&console.log("framesPattern: "+r.framesPattern);break;case"width":r.width=c,r.isVerbose&&console.log("width: "+r.width);break;case"maxWidth":r.maxWidth=c,r.isVerbose&&console.log("maxWidth: "+r.maxWidth);break;case"height":r.height=c,r.isVerbose&&console.log("height: "+r.height);break;case"maxHeight":r.maxHeight=c,r.isVerbose&&console.log("maxHeight: "+r.maxHeight);break;case"fps":r.fps=c,r.isVerbose&&console.log("fps: "+r.fps);break;case"maxFps":r.maxFps=c,r.isVerbose&&console.log("maxFps: "+r.maxFps);break;case"maxFrameCount":r.maxFrameCount=c,r.isVerbose&&console.log("maxFrameCount: "+r.maxFrameCount);break;case"timeout":r.timeout=c,r.isVerbose&&console.log("timeout: "+r.timeout);break;case"progress":r.progress=c,r.isVerbose&&console.log("progress: "+r.progress);break;case"allowedPlugins":plugin_injector_js_1.PluginInjector.loadAllowedPlugins(c,r.existsSync,r.readUtf8Sync);break;case"injectPage":plugin_injector_js_1.PluginInjector.injectPage=c,r.isVerbose&&console.log("injectPage: "+c);break;case"teleport":r.toTeleport=!0;break;case"dp":r.toDeletePreviousVersion=!0;break;case"noframes":r.toGenFrames=!1;break;case"report":r.reportFileName=c;break;case"server":r.serverName=c;break;case"config":var _=a(c);if(!_)return 0;if(r.isVerbose&&console.log("Loading Config "+_),!r.existsSync(_))throw"Config "+_+" doesn't exists";r.configPath=o(_)+"/";var f=r.readUtf8Sync(_),g=[],u=0;r.parseConfig(g,f,_,s),opts_parser_js_1.OptsParser.iterateArgOpts(!0,function(){return g[u++]},n)}})||(this.url&&this.framesPattern?1:0)},e.prototype.parseArgumentsAsync=function(e){e(this.parseArguments(this.args))},e.prototype.handleMessage=function(e,t,i){var o=this,n=this;function h(){n.frameNr++,n.frameNr>=n.frameCount&&(n.frameCount=n.frameNr+1),t(s.MSG_RENDER_DONE)}if(0===e.indexOf(s.MESSAGE_PREFIX))try{var c=(e=e.substr(s.MESSAGE_PREFIX.length)).split(s.CMD_VALUE_SEP),l=c[0],p=2===c.length?c[1]:"";switch(this.isVerbose&&console.log("Cmd: "+l+", Value: "+p),l){case s.MSG_READY:t(s.MSG_SERVER_READY);break;case s.MSG_RENDER:var _=r(this.framesPattern,this.frameNr);if(this.toGenFrames){if(a){a=!1;var f=_.match(/^(.+)\/([^/]+)$/);if(f){var g=f[1];this.existsSync(g)||(this.isVerbose?console.log("Creating Folder: "+g):this.logLevel>consts_js_1.Consts.LL_SILENT&&console.log("Creating Story frames on: "+g),this.mkdirpSync(g))}}i(this.rootPath+_,function(){o.isVerbose&&console.log("Saved: "+_),o.progress>0&&o.frameNr%o.progress==0&&console.log(new Array(2+o.frameNr/o.progress).join("▒")+" "+o.frameNr+" frames"),h()})}else h();break;case s.MSG_RENDER_FINISHED:this.generateReport();break;case s.MSG_SET_FRAME_NR:this.frameNr=parseInt(p),this.isVerbose&&console.log("frame-nr: "+this.frameNr),this.checkForValidFrame(this.frameNr,!0,"Invalid number frame nr");break;case s.MSG_SET_FRAME_COUNT:this.frameCount=parseInt(p),this.isVerbose&&console.log("frame-count: "+this.frameCount),this.checkForValidFrame(this.frameCount,!1,"Invalid number of frames count");break;case s.MSG_SET_FPS:this.fps=parseInt(p),this.isVerbose&&console.log("fps: "+this.fps),this.checkForValidFps();break;case s.MSG_LOG_MSG:console.log(p);break;case s.MSG_LOG_WARN:console.warn(p);break;case s.MSG_LOG_ERROR:console.error(p);break;case s.MSG_TELEPORT:var u=(this.configPath?this.configPath:this.rootPath)+"story.json";console.log("Created "+u),this.writeFileSync(u,p),this.exitServer();break;case s.MSG_EXIT:this.exitServer()}}catch(e){n.handleError(e.message)}},e.prototype.handleError=function(e){console.error(e),this.exitServer(opts_parser_js_1.OptsParser.ON_ERROR_EXIT_VALUE)},e.prototype.checkForValidFps=function(){if(this.fps<=0||this.fps>this.maxFps)throw"Invalid number of frames per second"},e.prototype.checkForValidFrame=function(e,s,r){if(s||!e||e<0||e>this.maxFrameCount)throw r},e.prototype.prepareServer=function(){if(plugin_injector_js_1.PluginInjector.inject(this.existsSync,this.readUtf8Sync,this.writeFileSync),this.width<=0||this.width>this.maxWidth||this.height<=0||this.height>this.maxHeight)throw"Invalid frame output size";if(this.checkForValidFps(),this.toDeletePreviousVersion){this.isVerbose&&console.log("Deleting previous frames");for(var e=this.frameNr;;){var s=r(this.framesPattern,e);if(this.isVerbose&&console.log("frameFileName: "+s),!this.existsSync(s))break;this.unlinkSync(s),e++}}},e.prototype.generateReport=function(){if(this.reportFileName&&this.toGenFrames){var e=o(this.framesPattern);this.reportFileName=this.reportFileName.replace("__FRAMES_DIR__",e);var s=this.framesPattern;e===s.substr(0,e.length)&&(s="./"+s.substr(e.length+1));var r={width:this.width,height:this.height,fps:this.fps,framecount:this.frameCount,framespattern:s,timestamp:(t=6e4*(new Date).getTimezoneOffset(),new Date(Date.now()-t).toISOString().substr(0,19).replace("T"," "))};this.mkdirpSync(o(this.reportFileName)),this.writeFileSync(this.reportFileName,JSON.stringify(r,null,2)),this.isVerbose&&console.log("Generated Report "+this.reportFileName),console.log("Generated "+this.frameCount+" frames")}var t},e.prototype.start=function(){var e=this;try{this.parseArgumentsAsync(function(s){switch(s){case 0:opts_parser_js_1.OptsParser.printUsage();break;case 1:e.prepareServer(),e.runServer()}})}catch(e){console.log("Server Error: "+(e.message||e.toString())),this.exitServer(opts_parser_js_1.OptsParser.ON_ERROR_EXIT_VALUE)}},e}();e.BaseServer=n}(ServerAgent=exports.ServerAgent||(exports.ServerAgent={}));